//FLACCO PIERO 00000000001 Prova 1

#include "function.h"

// Per fare l'esercizio 2 e' comodo definire una funzione per fare i confronti
int cmpOpinione(Opinione op1, Opinione op2) {
    if (op1.anno < op2.anno) return -1;
    if (op1.anno > op2.anno) return 1;

    // Se arrivo qui, vuol direi che le due opinioni sono dello stesso anno
    if (op1.mese < op2.mese) return -1;
    if (op1.mese > op2.mese) return 1;

    // Se arrivo qui, vuol dire che le due opinioni sono dello stesso mese
    if (op1.giorno < op2.giorno) return -1;
    if (op1.giorno > op2.giorno) return 1;

    // Se arrivo qui, vuol dire che le due opinioni son uguali
    return 0;
}

int controlloOpinione(Opinione* list, int dim, Opinione op) {
    int i;

    // Se esiste anche una sola opinione con data piu' recente, allora
    // l'opinione passata come parametro NON e' corretta
    for (i = 0; i < dim; ++i) {
        if (strcmp(list[i].codProd, op.codProd) == 0 &&
            strcmp(list[i].codCliente, op.codCliente) == 0) {
            // Controllo se l'opinione in lista e' piu' recente di "op"
            if (cmpOpinione(list[i], op) > 0)
                return 0;
        }
    }

    // Se arrivo fino a qui, vuol dire che "op" e' l'opinione piu' recente
    return 1;
}

int contaLibri(char* autore, Prodotto* p, int dim) {
    int res = 0;
    int i;

    for (i = 0; i < dim; ++i) {
        if (strcmp(p[i].autore, autore) == 0)
            res += p[i].quantProd;
    }

    return res;
}



Opinione* opinioniAutore(Opinione* o, int dimOp, Prodotto* p, int dimProd, int* dimOpAutore) {
    char autore[DIM_AUTORE];
    int i, j, k;
    Opinione* res = NULL;
    int trovato;

    printf("Su quale autore si desiderano ottenere le opinioni? ");
    scanf("%s", autore);

    // Conto il numero di opinioni sui libri di tale autore
    *dimOpAutore = 0;
    for (i = 0; i < dimOp; ++i) {

        // Controllo se l'onione riguarda un prodotto dell'autore specificato
        trovato = 0;
        for (j = 0; j < dimProd; ++j) {
            if (strcmp(o[i].codProd, p[j].codProd) == 0 &&
                strcmp(p[j].autore, autore) == 0) {
                trovato = 1;
                break;
            }
        }

        // Se l'autore del libro combacia, allore devo contare una opnione
        if (trovato)
            (*dimOpAutore)++;
    }

    // Alloco un array di opinioni dinamicamente
    res = (Opinione*) malloc((*dimOpAutore) * sizeof(Opinione));

    // Ripeto i due cicli di prima per riempire l'array
    k = 0;
    for (i = 0; i < dimOp; ++i) {
        // Controllo se l'onione riguarda un prodotto dell'autore specificato
        trovato = 0;
        for (j = 0; j < dimProd; ++j) {
            if (strcmp(o[i].codProd, p[j].codProd) == 0 &&
                strcmp(p[j].autore, autore) == 0) {
                trovato = 1;
                break;
            }
        }

        // Se l'autore del libro combacia, allora copio l'opinione nell'array
        if (trovato) {
            res[k] = o[i];
            k++;
        }
    }

    // Restituisco l'array
    return res;
}

void inserisciProdotto(char* fileName) {
    Prodotto* prod = NULL;
    int nProd = 0;
    int ok;
    Prodotto t;
    int i;
    FILE* fp = NULL;

    // Leggo l'elenco dei prodotti esistenti
    prod = readprodotti(fileName, &nProd);

    // Chiedo i dati su un nuovo prodotto all'utente
    ok = 0;
    while (!ok) {
        printf("Inserire i dati su un nuovo prodotto (codice autore nome quant anno): ");
        scanf("%s%s%s%d%d", t.codProd, t.autore, t.nomeProd, &t.quantProd, &t.annoDist);

        // Controllo se il prodotto esista gia'
        ok = 1;
        for (i = 0; i < nProd; ++i) {
            if (strcmp(prod[i].codProd, t.codProd) == 0) {
                ok = 0;
                break;
            }
        }

        // Se il codice era gia' presente, lo segnalo
        if (!ok)
            printf("Codice prodotto gia' presente. Ripetere l'operazione.\n");
    }

    // Quando arrivo qui, i dati sul nuovo prodotto sono disponibili

    // Apro il file in modalita' append
    if ((fp = fopen(fileName, "a")) == NULL) {
        printf("Errore nell'aprire il file in modalita' append\n");
        exit(1);
    }

    // Scrivo una nuova riga nel file
    fprintf(fp, "%s %s %s %d %d\n", t.codProd, t.autore, t.nomeProd, t.quantProd, t.annoDist);

    // Mai dimenticarsi di chiudere i file!!!
    fclose(fp);

    // Mai dimenticarsi di deallocare!!!
    free(prod);

}