//FLACCO PIERO 00000000001 Prova 1

#include "libri.h"

Prodotto* readprodotti(char* fileName, int* dim) {
    FILE* fp = NULL;
    Prodotto t;
    Prodotto* res = NULL;
    int i;

    // Apro il file con i libri
    if ((fp = fopen(fileName, "r")) == NULL) {
        printf("Errore nell'apertura del file");
        exit(1);
    }

    // Conto il numero di libri nel file
    *dim = 0;
    while (fscanf(fp, "%s%s%s%d%d", t.codProd, t.autore, t.nomeProd,
                                    &t.quantProd, &t.annoDist) == 5) {
        (*dim)++;
    }

    // Riporto il cursore di lettura all'inizio del file
    rewind(fp);

    // Alloco il vettore dinamico
    res = (Prodotto*) malloc((*dim) * sizeof(Prodotto));

    // Riempio il vettore
    for (i = 0; i < *dim; ++i) {
        fscanf(fp, "%s%s%s%d%d", t.codProd, t.autore, t.nomeProd,
                                    &t.quantProd, &t.annoDist);
        res[i] = t;
    }

    // Mai dimenticarsi di chiudere i file!!!
    fclose(fp);

    // Restituisco il vettore
    return res;
}


void stampaProdotto(Prodotto prod) {
    printf("%s %s %s %d %d\n", prod.codProd, prod.autore, prod.nomeProd,
                               prod.quantProd, prod.annoDist);
}

Opinione* leggiOpinioni(char* fileName, int* dim) {
    FILE* fp = NULL;
    Opinione t;
    Opinione* res = NULL;
    int i;

    // Apro il file con i libri
    if ((fp = fopen(fileName, "r")) == NULL) {
        printf("Errore nell'apertura del file");
        exit(1);
    }

    // Conto il numero di libri nel file
    *dim = 0;
    while (fscanf(fp, "%s%d%s%d%d%d", t.codProd, &t.votoProd, t.codCliente,
                                      &t.anno, &t.mese, &t.giorno) == 6) {
        (*dim)++;
    }

    // Riporto il cursore di lettura all'inizio del file
    rewind(fp);

    // Alloco il vettore dinamico
    res = (Opinione*) malloc((*dim) * sizeof(Opinione));

    // Riempio il vettore
    for (i = 0; i < *dim; ++i) {
        fscanf(fp, "%s%d%s%d%d%d", t.codProd, &t.votoProd, t.codCliente,
                                   &t.anno, &t.mese, &t.giorno);
        res[i] = t;
    }

    // Mai dimenticarsi di chiudere i file!!!
    fclose(fp);

    // Restituisco il vettore
    return res;
}