//FLACCO PIERO 00000000001 Prova 1

#include "libri.h"
#include "function.h"
#include "sorting.h"

int main() {
	Prodotto* prod = NULL;
	Opinione* op = NULL;
	Opinione* opAutore = NULL;
	int nProd = 0, nOp = 0, nOpAutore = 0;
	int i;

	// Leggo i dati sui libri
	prod = readprodotti("prodotti.txt", &nProd);

	// Stampo i dati sui libri
	printf("Lista dei libri\n");
	for (i = 0; i < nProd; ++i)
		stampaProdotto(prod[i]);

	// Leggo i dati sulle opinioni
	op = leggiOpinioni("opinioni.txt", &nOp);

	// Stampo i dati sulle opinioni
	printf("\n");
	printf("Lista delle opinioni\n");
	for (i = 0; i < nOp; ++i)
		printf("%s %d %s %d %d %d\n", op[i].codProd, op[i].votoProd, op[i].codCliente,
									  op[i].anno, op[i].mese, op[i].giorno);


	// Controllo se le varie opinioni sono corrette o meno
	printf("\n");
	for (i = 0; i < nOp; ++i) {
		if (controlloOpinione(op, nOp, op[i])) {
			printf("Opinione #%d OK\n", i+1);
		}
		else {
			printf("Opinione #%d ERRATA\n", i+1);
		}
	}

	// Calcolo la somma delle quantita' dei prodotti per l'autore1
	printf("\n");
	printf("N. libri dell'autore1: %d\n", contaLibri("autore1", prod, nProd));

	// Ottengo in un vettore le opinioni per un determinato autore
	opAutore = opinioniAutore(op, nOp, prod, nProd, &nOpAutore);
	
	for (i = 0; i < nOpAutore; ++i)
		printf("%s %d %s %d %d %d\n", opAutore[i].codProd, opAutore[i].votoProd,
									  opAutore[i].codCliente, opAutore[i].anno,
									  opAutore[i].mese, opAutore[i].giorno);	

	// Inserimento di un nuovo prodotto
	inserisciProdotto("prodotti.txt");

    //Aggiorno la lista prodotti
    prod = readprodotti("prodotti.txt",&nProd);


    sortLibri(prod,nProd);
    // Stampo i dati sui libri
	printf("Lista dei libri ordinati per codice\n");
	for (i = 0; i < nProd; ++i)
		stampaProdotto(prod[i]);


    sortOpinioni(op,nOp,prod,nProd);
    // Stampo i dati sui libri
	printf("Lista delle opinioni ordinate per autore e poi per voto decrescente\n");
	for (i = 0; i < nOp; ++i){        
        Prodotto prodOp = getProdotto(op[i].codProd,prod,nProd);
		printf("%s %d %s %d %d %d %s\n", op[i].codProd, op[i].votoProd, op[i].codCliente,
									  op[i].anno, op[i].mese, op[i].giorno, prodOp.autore);    
    }
	// Mai dimenticarsi di deallocare!!!
	free(prod);
	free(op);
	free(opAutore);

	return 0;
}