#include "sorting.h"
#include <string.h>


int cmpProdotto(Prodotto p1, Prodotto p2){
    return strcmp(p1.codProd,p2.codProd);
}

void scambiaProdotti(Prodotto* p1,Prodotto* p2){
    Prodotto temp = *p1;
    *p1=*p2;
    *p2=temp;
}



//CERCA UN PRODOTTO PER CODICE
Prodotto getProdotto(char* codProd,Prodotto books[], int nbooks){
    int i;    
    for(i=0;i<nbooks;i++){
        if(strcmp(codProd,books[i].codProd)==0){
            return books[i];
        }
    }
    printf("Attenzione codice prodotto non trovato!");
    exit(-1);
}


int cmpOpinionePerAutoreEVoto(Opinione o1, Opinione o2,Prodotto books[],int nbooks){
    Prodotto p1,p2;
    p1 = getProdotto(o1.codProd,books,nbooks);
    p2 = getProdotto(o2.codProd,books,nbooks);
    int cmpAutori = strcmp(p1.autore,p2.autore);
    if(cmpAutori != 0)
        return cmpAutori;
    else return o1.votoProd<o2.votoProd?1:o1.votoProd>o2.votoProd?-1:0;
}


int trovaPosMax(Prodotto v[], int n) {
	int i, posMax=0;
	for (i=1; i<n; i++)
		if (cmpProdotto( v[posMax],v[i])<0)
			posMax=i;
	return posMax;
}


//DEVE ORDINARE I PRODOTTI PER CODICE
//SCELTO NAIVESORT
void sortLibri(Prodotto v[],int n){
    int p;

	while (n>1) {
		p = trovaPosMax(v,n);		
		
        if ( p < n-1 )
			scambiaProdotti( &v[p], &v[n-1]);
		n--;
	}
}



void scambiaOpinioni(Opinione* o1,Opinione* o2){
    Opinione temp = *o1;
    *o1=*o2;
    *o2=temp;
}

//DEVE ORDINARE LE OPINIONI PER AUTORE E A PARITA' DI AUTORE PER VOTO DECRESCENTE
//SCELTO BUBBLESORT
void sortOpinioni(Opinione ops[],int nop, Prodotto books[],int nbooks){
    int i;
	int ordinato = 0;
	
	while (nop>1 && ordinato==0) {
		ordinato = 1;
		for (i=0; i<nop-1; i++) {
			if ( cmpOpinionePerAutoreEVoto(ops[i] , ops[i+1],books,nbooks)>0 ) {
				scambiaOpinioni( &ops[i], &ops[i+1]);
				ordinato = 0;
			}
		}
		nop--;
	}
}